diff --git a/content/browser/media/media_process_host_ui_shim.cc b/content/browser/media/media_process_host_ui_shim.cc
new file mode 100644
index 0000000..d5e6fe4
--- /dev/null
+++ b/content/browser/media/media_process_host_ui_shim.cc
@@ -0,0 +1,166 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/browser/media/media_process_host_ui_shim.h"
+
+#include <algorithm>
+
+#include "base/bind.h"
+#include "base/callback_helpers.h"
+#include "base/id_map.h"
+#include "base/lazy_instance.h"
+#include "base/strings/string_number_conversions.h"
+#include "base/trace_event/trace_event.h"
+#include "content/browser/media/media_data_manager_impl.h"
+#include "content/browser/media/media_process_host.h"
+#include "content/common/media/media_messages.h"
+#include "content/public/browser/browser_thread.h"
+
+namespace content {
+
+namespace {
+
+// One of the linux specific headers defines this as a macro.
+#ifdef DestroyAll
+#undef DestroyAll
+#endif
+
+base::LazyInstance<IDMap<MediaProcessHostUIShim>> g_hosts_by_id =
+    LAZY_INSTANCE_INITIALIZER;
+
+void SendOnIOThreadTask(int host_id, IPC::Message* msg) {
+  MediaProcessHost* host = MediaProcessHost::FromID(host_id);
+  if (host)
+    host->Send(msg);
+  else
+    delete msg;
+}
+
+class ScopedSendOnIOThread {
+ public:
+  ScopedSendOnIOThread(int host_id, IPC::Message* msg)
+      : host_id_(host_id), msg_(msg), cancelled_(false) {}
+
+  ~ScopedSendOnIOThread() {
+    if (!cancelled_) {
+      BrowserThread::PostTask(
+          BrowserThread::IO, FROM_HERE,
+          base::Bind(&SendOnIOThreadTask, host_id_, msg_.release()));
+    }
+  }
+
+  void Cancel() { cancelled_ = true; }
+
+ private:
+  int host_id_;
+  scoped_ptr<IPC::Message> msg_;
+  bool cancelled_;
+};
+
+}  // namespace
+
+void RouteToMediaProcessHostUIShimTask(int host_id, const IPC::Message& msg) {
+  MediaProcessHostUIShim* ui_shim = MediaProcessHostUIShim::FromID(host_id);
+  if (ui_shim)
+    ui_shim->OnMessageReceived(msg);
+}
+
+MediaProcessHostUIShim::MediaProcessHostUIShim(int host_id)
+    : host_id_(host_id) {
+  g_hosts_by_id.Pointer()->AddWithID(this, host_id_);
+}
+
+// static
+MediaProcessHostUIShim* MediaProcessHostUIShim::Create(int host_id) {
+  DCHECK(!FromID(host_id));
+  return new MediaProcessHostUIShim(host_id);
+}
+
+// static
+void MediaProcessHostUIShim::Destroy(int host_id, const std::string& message) {
+  DCHECK_CURRENTLY_ON(BrowserThread::UI);
+
+  MediaDataManagerImpl::GetInstance()->AddLogMessage(
+      logging::LOG_ERROR, "MediaProcessHostUIShim", message);
+
+  delete FromID(host_id);
+}
+
+// static
+void MediaProcessHostUIShim::DestroyAll() {
+  DCHECK_CURRENTLY_ON(BrowserThread::UI);
+  while (!g_hosts_by_id.Pointer()->IsEmpty()) {
+    IDMap<MediaProcessHostUIShim>::iterator it(g_hosts_by_id.Pointer());
+    delete it.GetCurrentValue();
+  }
+}
+
+// static
+MediaProcessHostUIShim* MediaProcessHostUIShim::FromID(int host_id) {
+  DCHECK_CURRENTLY_ON(BrowserThread::UI);
+  return g_hosts_by_id.Pointer()->Lookup(host_id);
+}
+
+// static
+MediaProcessHostUIShim* MediaProcessHostUIShim::GetOneInstance() {
+  DCHECK_CURRENTLY_ON(BrowserThread::UI);
+  if (g_hosts_by_id.Pointer()->IsEmpty())
+    return NULL;
+  IDMap<MediaProcessHostUIShim>::iterator it(g_hosts_by_id.Pointer());
+  return it.GetCurrentValue();
+}
+
+bool MediaProcessHostUIShim::Send(IPC::Message* msg) {
+  DCHECK(CalledOnValidThread());
+  return BrowserThread::PostTask(
+      BrowserThread::IO, FROM_HERE,
+      base::Bind(&SendOnIOThreadTask, host_id_, msg));
+}
+
+bool MediaProcessHostUIShim::OnMessageReceived(const IPC::Message& message) {
+  DCHECK(CalledOnValidThread());
+
+  if (message.routing_id() != MSG_ROUTING_CONTROL)
+    return false;
+
+  return OnControlMessageReceived(message);
+}
+
+void MediaProcessHostUIShim::SimulateClean() {
+  Send(new MediaMsg_Clean());
+}
+
+void MediaProcessHostUIShim::SimulateCrash() {
+  Send(new MediaMsg_Crash());
+}
+
+void MediaProcessHostUIShim::SimulateHang() {
+  Send(new MediaMsg_Hang());
+}
+
+MediaProcessHostUIShim::~MediaProcessHostUIShim() {
+  DCHECK(CalledOnValidThread());
+  g_hosts_by_id.Pointer()->Remove(host_id_);
+}
+
+bool MediaProcessHostUIShim::OnControlMessageReceived(
+    const IPC::Message& message) {
+  DCHECK(CalledOnValidThread());
+
+  IPC_BEGIN_MESSAGE_MAP(MediaProcessHostUIShim, message)
+    IPC_MESSAGE_HANDLER(MediaHostMsg_OnLogMessage, OnLogMessage)
+
+    IPC_MESSAGE_UNHANDLED_ERROR()
+  IPC_END_MESSAGE_MAP()
+
+  return true;
+}
+
+void MediaProcessHostUIShim::OnLogMessage(int level,
+                                          const std::string& header,
+                                          const std::string& message) {
+  MediaDataManagerImpl::GetInstance()->AddLogMessage(level, header, message);
+}
+
+}  // namespace content
diff --git a/content/browser/media/media_process_host_ui_shim.h b/content/browser/media/media_process_host_ui_shim.h
new file mode 100644
index 0000000..3fc5914
--- /dev/null
+++ b/content/browser/media/media_process_host_ui_shim.h
@@ -0,0 +1,84 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_BROWSER_MEDIA_MEDIA_PROCESS_HOST_UI_SHIM_H_
+#define CONTENT_BROWSER_MEDIA_MEDIA_PROCESS_HOST_UI_SHIM_H_
+
+// This class lives on the UI thread and supports classes
+// which must live on the UI thread. The IO thread
+// portion of this class, the MediaProcessHost, is responsible for
+// shuttling messages between the browser and media processes.
+
+#include <string>
+
+#include "base/callback.h"
+#include "base/compiler_specific.h"
+#include "base/memory/linked_ptr.h"
+#include "base/memory/ref_counted.h"
+#include "base/threading/non_thread_safe.h"
+#include "content/common/content_export.h"
+#include "content/common/message_router.h"
+#include "ipc/ipc_listener.h"
+#include "ipc/ipc_sender.h"
+
+namespace IPC {
+class Message;
+}
+
+namespace content {
+void RouteToMediaProcessHostUIShimTask(int host_id, const IPC::Message& msg);
+
+class MediaProcessHostUIShim : public IPC::Listener,
+                               public IPC::Sender,
+                               public base::NonThreadSafe {
+ public:
+  // Create a MediaProcessHostUIShim with the given ID.  The object can be found
+  // using FromID with the same id.
+  static MediaProcessHostUIShim* Create(int host_id);
+
+  // Destroy the MediaProcessHostUIShim with the given host ID. This can only
+  // be called on the UI thread. Only the GpuProcessHost should destroy the
+  // UI shim.
+  static void Destroy(int host_id, const std::string& message);
+
+  // Destroy all remaining MediaProcessHostUIShims.
+  CONTENT_EXPORT static void DestroyAll();
+
+  CONTENT_EXPORT static MediaProcessHostUIShim* FromID(int host_id);
+
+  // Get a MediaProcessHostUIShim instance; it doesn't matter which one.
+  // Return NULL if none has been created.
+  CONTENT_EXPORT static MediaProcessHostUIShim* GetOneInstance();
+
+  // IPC::Sender implementation.
+  bool Send(IPC::Message* msg) override;
+
+  // IPC::Listener implementation.
+  // The GpuProcessHost causes this to be called on the UI thread to
+  // dispatch the incoming messages from the GPU process, which are
+  // actually received on the IO thread.
+  bool OnMessageReceived(const IPC::Message& message) override;
+
+  CONTENT_EXPORT void SimulateClean();
+  CONTENT_EXPORT void SimulateCrash();
+  CONTENT_EXPORT void SimulateHang();
+
+ private:
+  explicit MediaProcessHostUIShim(int host_id);
+  ~MediaProcessHostUIShim() override;
+
+  // Message handlers.
+  bool OnControlMessageReceived(const IPC::Message& message);
+
+  void OnLogMessage(int level,
+                    const std::string& header,
+                    const std::string& message);
+
+  // The serial number of the MediaProcessHost / MediaProcessHostUIShim pair.
+  int host_id_;
+};
+
+}  // namespace content
+
+#endif  // CONTENT_BROWSER_MEDIA_MEDIA_PROCESS_HOST_UI_SHIM_H_
diff --git a/content/browser/renderer_host/media_message_filter.cc b/content/browser/renderer_host/media_message_filter.cc
new file mode 100644
index 0000000..76f8702
--- /dev/null
+++ b/content/browser/renderer_host/media_message_filter.cc
@@ -0,0 +1,76 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/browser/renderer_host/media_message_filter.h"
+
+#include "base/bind.h"
+#include "base/command_line.h"
+#include "content/browser/media/media_process_host.h"
+#include "content/common/media/media_messages.h"
+#include "content/public/common/content_switches.h"
+
+namespace content {
+
+MediaMessageFilter::MediaMessageFilter(int render_process_id)
+    : BrowserMessageFilter(MediaMsgStart),
+      media_process_id_(0),  // There is only one media process.
+      render_process_id_(render_process_id),
+      weak_ptr_factory_(this) {
+  DCHECK_CURRENTLY_ON(BrowserThread::UI);
+  DVLOG(1) << __FUNCTION__ << "(Create MediaMessageFilter)";
+}
+
+MediaMessageFilter::~MediaMessageFilter() {
+  DCHECK_CURRENTLY_ON(BrowserThread::IO);
+}
+
+bool MediaMessageFilter::OnMessageReceived(const IPC::Message& message) {
+  bool handled = true;
+  IPC_BEGIN_MESSAGE_MAP(MediaMessageFilter, message)
+    IPC_MESSAGE_HANDLER_DELAY_REPLY(MediaHostMsg_EstablishMediaChannel,
+                                    OnEstablishMediaChannel)
+    IPC_MESSAGE_UNHANDLED(handled = false)
+  IPC_END_MESSAGE_MAP()
+  return handled;
+}
+
+void MediaMessageFilter::OnEstablishMediaChannel(
+    CauseForMediaLaunch cause_for_media_launch,
+    IPC::Message* reply_ptr) {
+  DCHECK_CURRENTLY_ON(BrowserThread::IO);
+  scoped_ptr<IPC::Message> reply(reply_ptr);
+
+  MediaProcessHost* host = MediaProcessHost::FromID(media_process_id_);
+  if (!host) {
+    DVLOG(1) << __FUNCTION__ << "(Launching Media Process)";
+    host = MediaProcessHost::Get(MediaProcessHost::MEDIA_PROCESS_KIND_SANDBOXED,
+                                 cause_for_media_launch);
+    if (!host) {
+      reply->set_reply_error();
+      Send(reply.release());
+      return;
+    }
+
+    media_process_id_ = host->host_id();
+  }
+
+  DVLOG(1) << __FUNCTION__ << "(Establishing channel)";
+
+  host->EstablishMediaChannel(
+      render_process_id_,
+      base::Bind(&MediaMessageFilter::EstablishChannelCallback,
+                 weak_ptr_factory_.GetWeakPtr(), base::Passed(&reply)));
+}
+
+void MediaMessageFilter::EstablishChannelCallback(
+    scoped_ptr<IPC::Message> reply,
+    const IPC::ChannelHandle& channel) {
+  DCHECK_CURRENTLY_ON(BrowserThread::IO);
+  DVLOG(1) << __FUNCTION__ << "(Media channel established)";
+  MediaHostMsg_EstablishMediaChannel::WriteReplyParams(
+      reply.get(), render_process_id_, channel);
+  Send(reply.release());
+}
+
+}  // namespace content
diff --git a/content/browser/renderer_host/media_message_filter.h b/content/browser/renderer_host/media_message_filter.h
new file mode 100644
index 0000000..10570e2
--- /dev/null
+++ b/content/browser/renderer_host/media_message_filter.h
@@ -0,0 +1,58 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_BROWSER_RENDERER_HOST_MEDIA_MESSAGE_FILTER_H_
+#define CONTENT_BROWSER_RENDERER_HOST_MEDIA_MESSAGE_FILTER_H_
+
+#include <vector>
+
+#include "base/memory/linked_ptr.h"
+#include "base/memory/ref_counted.h"
+#include "base/memory/scoped_ptr.h"
+#include "base/memory/weak_ptr.h"
+#include "base/sequenced_task_runner_helpers.h"
+#include "content/common/media/media_process_launch_causes.h"
+#include "content/public/browser/browser_message_filter.h"
+
+class MediaProcessHost;
+
+namespace content {
+class RenderWidgetHelper;
+class RenderWidgetHostViewFrameSubscriber;
+
+// A message filter for messages from the renderer to the
+// MediaProcessHost(UIShim)
+// in the browser. Such messages are typically destined for the media process,
+// but need to be mediated by the browser.
+class MediaMessageFilter : public BrowserMessageFilter {
+ public:
+  MediaMessageFilter(int render_process_id);
+
+  // BrowserMessageFilter methods:
+  bool OnMessageReceived(const IPC::Message& message) override;
+
+ private:
+  friend class BrowserThread;
+  friend class base::DeleteHelper<MediaMessageFilter>;
+
+  ~MediaMessageFilter() override;
+
+  // Message handlers called on the browser IO thread:
+  void OnEstablishMediaChannel(CauseForMediaLaunch, IPC::Message* reply);
+
+  // Helper callbacks for the message handlers.
+  void EstablishChannelCallback(scoped_ptr<IPC::Message> reply,
+                                const IPC::ChannelHandle& channel);
+
+  int media_process_id_;
+  int render_process_id_;
+
+  base::WeakPtrFactory<MediaMessageFilter> weak_ptr_factory_;
+
+  DISALLOW_COPY_AND_ASSIGN(MediaMessageFilter);
+};
+
+}  // namespace content
+
+#endif  // CONTENT_BROWSER_RENDERER_HOST_MEDIA_MESSAGE_FILTER_H_
diff --git a/content/browser/renderer_host/render_process_host_impl.cc b/content/browser/renderer_host/render_process_host_impl.cc
index 248ed1d..06c6509 100644
--- a/content/browser/renderer_host/render_process_host_impl.cc
+++ b/content/browser/renderer_host/render_process_host_impl.cc
@@ -169,6 +169,11 @@
 #include "ui/gl/gpu_switching_manager.h"
 #include "ui/native_theme/native_theme_switches.h"
 
+#if defined(USE_GSTREAMER)
+#include "content/browser/media/media_process_host.h"
+#include "content/browser/renderer_host/media_message_filter.h"
+#endif
+
 #if defined(OS_ANDROID)
 #include "content/browser/android/child_process_launcher_android.h"
 #include "content/browser/media/android/browser_demuxer_android.h"
@@ -809,6 +814,12 @@ void RenderProcessHostImpl::CreateMessageFilters() {
 
   gpu_message_filter_ = new GpuMessageFilter(GetID(), widget_helper_.get());
   AddFilter(gpu_message_filter_);
+
+#if defined(USE_GSTREAMER)
+  media_message_filter_ = new MediaMessageFilter(GetID());
+  AddFilter(media_message_filter_);
+#endif
+
 #if defined(ENABLE_WEBRTC)
   AddFilter(new WebRTCIdentityServiceHost(
       GetID(), storage_partition_impl_->GetWebRTCIdentityStore()));
@@ -1381,6 +1392,9 @@ void RenderProcessHostImpl::PropagateBrowserCommandLineToRenderer(
     switches::kDisableWebAudio,
     switches::kRendererWaitForJavaDebugger,
 #endif
+#if defined(USE_GSTREAMER)
+    switches::kEnableGStreamerMediaBackend,
+#endif
 #if defined(OS_MACOSX)
     // Allow this to be set when invoking the browser and relayed along.
     switches::kEnableSandboxLogging,
@@ -1685,6 +1699,9 @@ void RenderProcessHostImpl::Cleanup() {
 
     // The following members should be cleared in ProcessDied() as well!
     gpu_message_filter_ = NULL;
+#if defined(USE_GSTREAMER)
+    media_message_filter_ = NULL;
+#endif
     message_port_message_filter_ = NULL;
 #if defined(ENABLE_BROWSER_CDMS)
     browser_cdm_manager_ = NULL;
diff --git a/content/browser/renderer_host/render_process_host_impl.h b/content/browser/renderer_host/render_process_host_impl.h
index 8937fd1..f92e5f8 100644
--- a/content/browser/renderer_host/render_process_host_impl.h
+++ b/content/browser/renderer_host/render_process_host_impl.h
@@ -52,6 +52,9 @@ class BrowserCdmManager;
 class BrowserDemuxerAndroid;
 class GpuMessageFilter;
 class InProcessChildThreadParams;
+#if defined(USE_GSTREAMER)
+class MediaMessageFilter;
+#endif
 class MessagePortMessageFilter;
 class MojoApplicationHost;
 class NotificationMessageFilter;
@@ -376,6 +379,11 @@ class CONTENT_EXPORT RenderProcessHostImpl
   // it's valid if non-NULL.
   GpuMessageFilter* gpu_message_filter_;
 
+#if defined(USE_GSTREAMER)
+  // The filter for media related messages coming from the renderer.
+  MediaMessageFilter* media_message_filter_;
+#endif
+
   // The filter for MessagePort messages coming from the renderer.
   scoped_refptr<MessagePortMessageFilter> message_port_message_filter_;
 
diff --git a/content/common/child_process_host_impl.cc b/content/common/child_process_host_impl.cc
index 45ede03..b651c3a 100644
--- a/content/common/child_process_host_impl.cc
+++ b/content/common/child_process_host_impl.cc
@@ -171,8 +171,25 @@ ChildProcessHostImpl::~ChildProcessHostImpl() {
 void ChildProcessHostImpl::AddFilter(IPC::MessageFilter* filter) {
   filters_.push_back(filter);
 
+// TODO: Remove.
+// This is a temporary solution to allow adding ResourceMessageFilter
+// dynamically after the channel is created.
+// It will be removed when we find the way to use the resource storage in media
+// process.
+// See MediaProcessHost::CreateResourceMessageFilter for more details.
+#if defined(USE_GSTREAMER)
+  if (channel_) {
+    filter->OnFilterAdded(channel_.get());
+
+    // Adding filter after being connected.
+    if (peer_process_.IsValid()) {
+      filter->OnChannelConnected(peer_process_.Pid());
+    }
+  }
+#else
   if (channel_)
     filter->OnFilterAdded(channel_.get());
+#endif
 }
 
 void ChildProcessHostImpl::ForceShutdown() {
diff --git a/content/common/content_constants_internal.cc b/content/common/content_constants_internal.cc
index afd5a17..5a39534 100644
--- a/content/common/content_constants_internal.cc
+++ b/content/common/content_constants_internal.cc
@@ -15,6 +15,9 @@ const uint32 kMaxPluginSize = 8 << 20;
 // 10MiB
 const size_t kMaxLengthOfDataURLString = 1024 * 1024 * 10;
 
+#if defined(USE_GSTREAMER)
+const int kTraceEventMediaProcessSortIndex = -7;
+#endif
 const int kTraceEventBrowserProcessSortIndex = -6;
 const int kTraceEventRendererProcessSortIndex = -5;
 const int kTraceEventPluginProcessSortIndex = -4;
diff --git a/content/common/content_constants_internal.h b/content/common/content_constants_internal.h
index a5ce925..b93d7be 100644
--- a/content/common/content_constants_internal.h
+++ b/content/common/content_constants_internal.h
@@ -23,6 +23,9 @@ extern const uint32 kMaxPluginSize;
 extern const size_t kMaxLengthOfDataURLString;
 
 // Constants used to organize content processes in about:tracing.
+#if defined(USE_GSTREAMER)
+CONTENT_EXPORT extern const int kTraceEventMediaProcessSortIndex;
+#endif
 CONTENT_EXPORT extern const int kTraceEventBrowserProcessSortIndex;
 CONTENT_EXPORT extern const int kTraceEventRendererProcessSortIndex;
 CONTENT_EXPORT extern const int kTraceEventPluginProcessSortIndex;
diff --git a/content/common/content_message_generator.h b/content/common/content_message_generator.h
index 803e5f6..3c0a465 100644
--- a/content/common/content_message_generator.h
+++ b/content/common/content_message_generator.h
@@ -63,6 +63,11 @@
 #include "content/common/websocket_messages.h"
 #include "content/common/worker_messages.h"
 
+#if defined(USE_GSTREAMER)
+#include "content/common/media/media_messages.h"
+#include "content/common/media/media_player_messages_gstreamer.h"
+#endif
+
 #if defined(ENABLE_WEBRTC)
 #include "content/common/p2p_messages.h"
 #endif
diff --git a/content/common/gpu/client/command_buffer_metrics.cc b/content/common/gpu/client/command_buffer_metrics.cc
index d16f276..4cd714b 100644
--- a/content/common/gpu/client/command_buffer_metrics.cc
+++ b/content/common/gpu/client/command_buffer_metrics.cc
@@ -95,6 +95,12 @@ void RecordContextLost(CommandBufferContextType type,
       UMA_HISTOGRAM_ENUMERATION("GPU.ContextLost.VideoAccelerator", reason,
                                 CONTEXT_LOST_REASON_MAX_ENUM);
       break;
+#if defined(USE_GSTREAMER)
+    case MEDIA_GSTREAMER_CONTEXT:
+      UMA_HISTOGRAM_ENUMERATION("GPU.ContextLost.MediaGStreamer", reason,
+                                CONTEXT_LOST_REASON_MAX_ENUM);
+      break;
+#endif
     case OFFSCREEN_VIDEO_CAPTURE_CONTEXT:
       UMA_HISTOGRAM_ENUMERATION("GPU.ContextLost.VideoCapture", reason,
                                 CONTEXT_LOST_REASON_MAX_ENUM);
@@ -132,6 +138,10 @@ std::string CommandBufferContextTypeToString(CommandBufferContextType type) {
       return "Offscreen-CaptureThread";
     case OFFSCREEN_CONTEXT_FOR_WEBGL:
       return "Offscreen-For-WebGL";
+#if defined(USE_GSTREAMER)
+    case MEDIA_GSTREAMER_CONTEXT:
+      return "Offscreen-For-Media-GStreamer";
+#endif
     default:
       NOTREACHED();
       return "unknown";
diff --git a/content/common/gpu/client/command_buffer_metrics.h b/content/common/gpu/client/command_buffer_metrics.h
index e198d85..e29872f 100644
--- a/content/common/gpu/client/command_buffer_metrics.h
+++ b/content/common/gpu/client/command_buffer_metrics.h
@@ -18,6 +18,9 @@ enum CommandBufferContextType {
   RENDER_WORKER_CONTEXT,
   RENDERER_MAINTHREAD_CONTEXT,
   GPU_VIDEO_ACCELERATOR_CONTEXT,
+#if defined(USE_GSTREAMER)
+  MEDIA_GSTREAMER_CONTEXT,
+#endif
   OFFSCREEN_VIDEO_CAPTURE_CONTEXT,
   OFFSCREEN_CONTEXT_FOR_WEBGL,
   CONTEXT_TYPE_UNKNOWN,
diff --git a/content/common/gpu/client/command_buffer_proxy_impl.cc b/content/common/gpu/client/command_buffer_proxy_impl.cc
index 60cc94a..46853f4 100644
--- a/content/common/gpu/client/command_buffer_proxy_impl.cc
+++ b/content/common/gpu/client/command_buffer_proxy_impl.cc
@@ -25,6 +25,10 @@
 #include "ui/gfx/geometry/size.h"
 #include "ui/gl/gl_bindings.h"
 
+#if defined(USE_GSTREAMER) && defined(OS_POSIX)
+#include "ipc/ipc_platform_file_attachment_posix.h"
+#endif
+
 namespace content {
 
 CommandBufferProxyImpl::CommandBufferProxyImpl(GpuChannelHost* channel,
@@ -436,6 +440,41 @@ int CommandBufferProxyImpl::GetRouteID() const {
   return route_id_;
 }
 
+#if defined(USE_GSTREAMER)
+int32_t CommandBufferProxyImpl::CreateEGLImage(
+    size_t width,
+    size_t height,
+    const std::vector<int32_t>& attributes,
+    const std::vector<int32_t>& dmabuf_fds) {
+  CheckLock();
+  if (last_state_.error != gpu::error::kNoError)
+    return -1;
+
+  if (!channel_ || channel_->IsLost())
+    return -1;
+
+  int32 new_id = channel_->ReserveImageId();
+
+  IPC::Message* msg = new GpuCommandBufferMsg_CreateEGLImage(
+      route_id_, new_id, gfx::Size(width, height), attributes);
+
+  for (size_t i = 0; i < dmabuf_fds.size(); ++i) {
+    bool write_ret = msg->WriteAttachment(
+        new IPC::internal::PlatformFileAttachment(dmabuf_fds[i]));
+    if (!write_ret)
+      return -1;
+  }
+
+  // GpuChannelHost has a thread safe sender sync_filter_ so it is fine to call
+  // it from any thread. It matchs usage of eglCreateImage with EGL_NO_CONTEXT.
+  if (!Send(msg)) {
+    return -1;
+  }
+
+  return new_id;
+}
+#endif
+
 uint32 CommandBufferProxyImpl::CreateStreamTexture(uint32 texture_id) {
   CheckLock();
   if (last_state_.error != gpu::error::kNoError)
diff --git a/content/common/gpu/client/command_buffer_proxy_impl.h b/content/common/gpu/client/command_buffer_proxy_impl.h
index e248891..4c3d071 100644
--- a/content/common/gpu/client/command_buffer_proxy_impl.h
+++ b/content/common/gpu/client/command_buffer_proxy_impl.h
@@ -109,6 +109,14 @@ class CommandBufferProxyImpl
                                    size_t height,
                                    unsigned internalformat,
                                    unsigned usage) override;
+
+#if defined(USE_GSTREAMER)
+  int32_t CreateEGLImage(size_t width,
+                         size_t height,
+                         const std::vector<int32_t>& attributes,
+                         const std::vector<int32_t>& dmabuf_fds);
+#endif
+
   uint32 InsertSyncPoint() override;
   uint32_t InsertFutureSyncPoint() override;
   void RetireSyncPoint(uint32_t sync_point) override;
diff --git a/content/common/gpu/gpu_channel.cc b/content/common/gpu/gpu_channel.cc
index 6078d74..04299d2 100644
--- a/content/common/gpu/gpu_channel.cc
+++ b/content/common/gpu/gpu_channel.cc
@@ -45,6 +45,10 @@
 #include "ipc/ipc_channel_posix.h"
 #endif
 
+#if defined(USE_GSTREAMER)
+#include "ui/gl/gl_image_egl.h"
+#endif
+
 namespace content {
 namespace {
 
@@ -869,6 +873,34 @@ scoped_refptr<gfx::GLImage> GpuChannel::CreateImageForGpuMemoryBuffer(
   }
 }
 
+#if defined(USE_GSTREAMER)
+scoped_refptr<gfx::GLImage> GpuChannel::CreateEGLImage(
+    const gfx::Size& size,
+    const std::vector<int32>& attributes,
+    const std::vector<int32>& dmabuf_fds) {
+  scoped_refptr<gfx::GLImageEGL> image(new gfx::GLImageEGL(size));
+
+  EGLint* attrs = const_cast<EGLint*>(attributes.data());
+  for (size_t i = 0; i < 20; ++i) {
+    if (attrs[i] == EGL_DMA_BUF_PLANE0_FD_EXT) {
+      attrs[i + 1] = dmabuf_fds[0];
+    } else if (attrs[i] == EGL_DMA_BUF_PLANE1_FD_EXT) {
+      attrs[i + 1] = dmabuf_fds[1];
+    } else if (attrs[i] == EGL_DMA_BUF_PLANE2_FD_EXT) {
+      attrs[i + 1] = dmabuf_fds[2];
+    } else if (attrs[i] == EGL_NONE) {
+      break;
+    }
+  }
+
+  if (!image->Initialize(EGL_LINUX_DMA_BUF_EXT,
+                         static_cast<EGLClientBuffer>(nullptr), attrs))
+    return scoped_refptr<gfx::GLImageEGL>();
+
+  return image;
+}
+#endif
+
 void GpuChannel::HandleUpdateValueState(
     unsigned int target, const gpu::ValueState& state) {
   pending_valuebuffer_state_->UpdateState(target, state);
diff --git a/content/common/gpu/gpu_channel.h b/content/common/gpu/gpu_channel.h
index 6920df5..36b81c7 100644
--- a/content/common/gpu/gpu_channel.h
+++ b/content/common/gpu/gpu_channel.h
@@ -164,6 +164,13 @@ class GpuChannel : public IPC::Listener,
       gfx::GpuMemoryBuffer::Format format,
       uint32 internalformat);
 
+#if defined(USE_GSTREAMER)
+  scoped_refptr<gfx::GLImage> CreateEGLImage(
+      const gfx::Size& size,
+      const std::vector<int32>& attributes,
+      const std::vector<int32>& dmabuf_fds);
+#endif
+
   bool allow_future_sync_points() const { return allow_future_sync_points_; }
 
   void HandleUpdateValueState(unsigned int target,
diff --git a/content/common/gpu/gpu_command_buffer_stub.cc b/content/common/gpu/gpu_command_buffer_stub.cc
index 81a6e2c..450d13b 100644
--- a/content/common/gpu/gpu_command_buffer_stub.cc
+++ b/content/common/gpu/gpu_command_buffer_stub.cc
@@ -179,7 +179,12 @@ GpuCommandBufferStub::GpuCommandBufferStub(
       delayed_work_scheduled_(false),
       previous_messages_processed_(0),
       active_url_(active_url),
+#if defined(USE_GSTREAMER)
+      total_gpu_memory_(0),
+      dmabuf_fds_(3, 0) {
+#else
       total_gpu_memory_(0) {
+#endif
   active_url_hash_ = base::Hash(active_url.possibly_invalid_spec());
   FastSetActiveURL(active_url_, active_url_hash_);
 
@@ -251,6 +256,21 @@ bool GpuCommandBufferStub::OnMessageReceived(const IPC::Message& message) {
     have_context = true;
   }
 
+#if defined(USE_GSTREAMER)
+  if (message.type() == GpuCommandBufferMsg_CreateEGLImage::ID) {
+    scoped_refptr<IPC::MessageAttachment> attachment;
+    base::PickleIterator iter(message);
+    if (iter.SkipBytes(68)) {
+      for (int i = 0; i < 3; ++i) {
+        if (message.ReadAttachment(&iter, &attachment))
+          dmabuf_fds_[i] = attachment->TakePlatformFile();
+        else
+          break;
+      }
+    }
+  }
+#endif
+
   // Always use IPC_MESSAGE_HANDLER_DELAY_REPLY for synchronous message handlers
   // here. This is so the reply can be delayed if the scheduler is unscheduled.
   bool handled = true;
@@ -288,6 +308,9 @@ bool GpuCommandBufferStub::OnMessageReceived(const IPC::Message& message) {
         OnSetClientHasMemoryAllocationChangedCallback)
     IPC_MESSAGE_HANDLER(GpuCommandBufferMsg_CreateImage, OnCreateImage);
     IPC_MESSAGE_HANDLER(GpuCommandBufferMsg_DestroyImage, OnDestroyImage);
+#if defined(USE_GSTREAMER)
+    IPC_MESSAGE_HANDLER(GpuCommandBufferMsg_CreateEGLImage, OnCreateEGLImage);
+#endif
     IPC_MESSAGE_HANDLER(GpuCommandBufferMsg_CreateStreamTexture,
                         OnCreateStreamTexture)
     IPC_MESSAGE_UNHANDLED(handled = false)
@@ -520,6 +543,17 @@ void GpuCommandBufferStub::OnInitialize(
       }
       channel_->share_group()->SetSharedContext(context.get());
     }
+
+#if defined(USE_GSTREAMER)
+    if (!handle_.is_null() &&
+        surface_->GetConfig() !=
+            channel_->gpu_channel_manager()
+                ->GetDefaultOffscreenSurface()
+                ->GetConfig())
+      LOG(ERROR) << "OFF and ON screenSurface do not have the same EGLConfig, "
+                    "eglMakeCurrent might fail.";
+#endif
+
     // This should be a non-virtual GL context.
     DCHECK(context->GetHandle());
     context = new gpu::GLContextVirtual(
@@ -1009,6 +1043,35 @@ void GpuCommandBufferStub::OnDestroyImage(int32 id) {
   image_manager->RemoveImage(id);
 }
 
+#if defined(USE_GSTREAMER)
+void GpuCommandBufferStub::OnCreateEGLImage(
+    int32 id,
+    gfx::Size size,
+    const std::vector<int32>& attributes) {
+  TRACE_EVENT0("gpu", "GpuCommandBufferStub::OnCreateEGLImage");
+
+  if (!decoder_)
+    return;
+
+  gpu::gles2::ImageManager* image_manager = decoder_->GetImageManager();
+  DCHECK(image_manager);
+  if (image_manager->LookupImage(id)) {
+    LOG(ERROR) << "Image already exists with same ID.";
+    return;
+  }
+
+  scoped_refptr<gfx::GLImage> image =
+      channel()->CreateEGLImage(size, attributes, dmabuf_fds_);
+  dmabuf_fds_[0] = dmabuf_fds_[1] = dmabuf_fds_[2] = 0;
+  if (!image.get()) {
+    LOG(ERROR) << "channel()->CreateEGLImage failed.";
+    return;
+  }
+
+  image_manager->AddImage(image.get(), id);
+}
+#endif
+
 void GpuCommandBufferStub::SendConsoleMessage(
     int32 id,
     const std::string& message) {
diff --git a/content/common/gpu/gpu_command_buffer_stub.h b/content/common/gpu/gpu_command_buffer_stub.h
index f9e6207..f8caa3f 100644
--- a/content/common/gpu/gpu_command_buffer_stub.h
+++ b/content/common/gpu/gpu_command_buffer_stub.h
@@ -215,6 +215,12 @@ class GpuCommandBufferStub
                      uint32 internalformat);
   void OnDestroyImage(int32 id);
 
+#if defined(USE_GSTREAMER)
+  void OnCreateEGLImage(int32 id,
+                        gfx::Size size,
+                        const std::vector<int32>& attributes);
+#endif
+
   void OnCommandProcessed();
   void OnParseError();
   void OnCreateStreamTexture(
@@ -289,6 +295,10 @@ class GpuCommandBufferStub
   scoped_ptr<WaitForCommandState> wait_for_token_;
   scoped_ptr<WaitForCommandState> wait_for_get_offset_;
 
+#if defined(USE_GSTREAMER)
+  std::vector<int32> dmabuf_fds_;
+#endif
+
   DISALLOW_COPY_AND_ASSIGN(GpuCommandBufferStub);
 };
 
diff --git a/content/common/gpu/gpu_messages.h b/content/common/gpu/gpu_messages.h
index c60cfad..42823eb 100644
--- a/content/common/gpu/gpu_messages.h
+++ b/content/common/gpu/gpu_messages.h
@@ -646,6 +646,14 @@ IPC_MESSAGE_ROUTED5(GpuCommandBufferMsg_CreateImage,
 IPC_MESSAGE_ROUTED1(GpuCommandBufferMsg_DestroyImage,
                     int32 /* id */)
 
+#if defined(USE_GSTREAMER)
+// Create an EGLImage.
+IPC_MESSAGE_ROUTED3(GpuCommandBufferMsg_CreateEGLImage,
+                    int32 /* id */,
+                    gfx::Size /* size */,
+                    std::vector<int32> /* attributes */)
+#endif
+
 // Attaches an external image stream to the client texture.
 IPC_SYNC_MESSAGE_ROUTED2_1(GpuCommandBufferMsg_CreateStreamTexture,
                            uint32, /* client_texture_id */
diff --git a/content/common/gpu/gpu_process_launch_causes.h b/content/common/gpu/gpu_process_launch_causes.h
index 7524827..e7148e2 100644
--- a/content/common/gpu/gpu_process_launch_causes.h
+++ b/content/common/gpu/gpu_process_launch_causes.h
@@ -22,6 +22,9 @@ enum CauseForGpuLaunch {
   CAUSE_FOR_GPU_LAUNCH_PEPPERVIDEOENCODERACCELERATOR_INITIALIZE,
   CAUSE_FOR_GPU_LAUNCH_GPU_MEMORY_BUFFER_ALLOCATE,
   CAUSE_FOR_GPU_LAUNCH_JPEGDECODEACCELERATOR_INITIALIZE,
+#if defined(USE_GSTREAMER)
+  CAUSE_FOR_GPU_LAUNCH_MEDIA_GSTREAMER_CONTEXT_INITIALIZE,
+#endif
 
   // All new values should be inserted above this point so that
   // existing values continue to match up with those in histograms.xml.
